@import "./_variables.scss";

$spacingSizes: (
    xxtiny: 0.2rem,
    xtiny: 0.4rem,
    tiny: 0.8rem,
    normal: 1.6rem,
    big: 3.2rem,
    xbig: 6.4rem,
    xxbig: 12.8rem,
    huge: 25.6rem,
) !default;

$spacingClasses: (
    margin: 'margin',
    margin-left: 'margin-left',
    margin-right: 'margin-right',
    margin-top: 'margin-top',
    margin-bottom: 'margin-bottom',
    margin-horizontal: ('margin-left', 'margin-right'),
    margin-vertical: ('margin-top', 'margin-bottom'),
    padding: 'padding',
    padding-left: 'padding-left',
    padding-right: 'padding-right',
    padding-top: 'padding-top',
    padding-bottom: 'padding-bottom',
    padding-horizontal: ('padding-left', 'padding-right'),
    padding-vertical: ('padding-top', 'padding-bottom'),
    position-top: 'top',
    position-bottom: 'bottom',
    position-left: 'left',
    position-right: 'right'
) !default;

$negativeSpacingClasses: (
    negative-margin: 'margin',
    negative-margin-left: 'margin-left',
    negative-margin-right: 'margin-right',
    negative-margin-top: 'margin-top',
    negative-margin-bottom: 'margin-bottom',
    negative-margin-horizontal: ('margin-left', 'margin-right'),
    negative-margin-vertical: ('margin-top', 'margin-bottom'),
);

.position {
    &-absolute {
        position: absolute;
    }
    &-relative {
        position: relative;
    }
}

@mixin param($params, $spacingSizes: $spacingSizes) {
    @if type-of($params) == list {
        &-0 { 
            @each $item in $params {
                #{$item}: 0;
            }
        }
        &-auto { 
            @each $item in $params {
                #{$item}: auto;
            }
        }
        @each $size in map-keys($spacingSizes) {
            &-#{$size} {
                @each $item in $params {
                    #{$item}: map-get($spacingSizes, $size);
                }
            }
        }
    } @else {
        &-0 { 
            @each $item in $params {
                #{$item}: 0;
            }
        }
        &-auto { 
            @each $item in $params {
                #{$item}: auto;
            }
        }
        @each $size in map-keys($spacingSizes) {
            &-#{$size} {
                #{$params}: map-get($spacingSizes, $size);
            }
        }
    }
}

@mixin negativeParam($params, $spacingSizes: $spacingSizes) {
    @if type-of($params) == list {
        @each $size in map-keys($spacingSizes) {
            &-#{$size} {
                @each $item in $params {
                    #{$item}: - map-get($spacingSizes, $size);
                }
            }
        }
    } @else {
        @each $size in map-keys($spacingSizes) {
            &-#{$size} {
                #{$params}: - map-get($spacingSizes, $size);
            }
        }
    }
}

@each $class in map-keys($spacingClasses) {
    .#{$class} {
        @include param(map-get($spacingClasses, $class));
        @each $breakpoint in map-keys($breakpoints) {
            &-#{$breakpoint} {
                @media (min-width: map-get($breakpoints, $breakpoint)) {
                    @include param(map-get($spacingClasses, $class));
                }
            }
        }
    }
}

@each $classe in map-keys($negativeSpacingClasses) {
    .#{$classe} {
        @include negativeParam(map-get($negativeSpacingClasses, $classe));
        @each $breakpoint in map-keys($breakpoints) {
            &-#{$breakpoint} {
                @media (min-width: map-get($breakpoints, $breakpoint)) {
                    @include negativeParam(map-get($negativeSpacingClasses, $classe));
                }
            }
        }
    }
}